﻿using Auth.Models;
using Avalonia.Media;
using Avalonia.Styling;
using ReactiveUI;
using System;
using System.Drawing;
using System.Security.Cryptography.X509Certificates;
using Avalonia.Controls;
using Avalonia.Controls.Shapes;
using System.Linq;
using Avalonia.Threading;
using MsBox.Avalonia.Enums;
using MsBox.Avalonia;

namespace Auth.ViewModels
{
    public class AuthVM : ReactiveObject
    {
        public DispatcherTimer timer = new DispatcherTimer();
        public string kod = "";
        public string _login = "";
        public string _password = "";
        public string check = "";
        public string error = "";
        public bool ButtonVisible = true;
        public bool TextVisible = false;
        public bool _Enabled = true;
        private string _errorMessage;

        public string Login
        {
            get
            {
                return _login;
            }
            set
            {
                this.RaiseAndSetIfChanged(ref _login, value);
            }
        }

        public bool Enabled
        {
            get
            {
                return _Enabled;
            }
            set
            {
                this.RaiseAndSetIfChanged(ref _Enabled, value);
            }
        }

        public string Password
        {
            get
            {
                return _password;
            }
            set
            {
                this.RaiseAndSetIfChanged(ref _password, value);
            }
        }


        public bool Visible
        {
            get
            {
                return ButtonVisible;
            }
            set
            {
                this.RaiseAndSetIfChanged(ref ButtonVisible, value);
            }
        }

        public bool VisibleText
        {
            get
            {
                return TextVisible;
            }
            set
            {
                this.RaiseAndSetIfChanged(ref TextVisible, value);
            }
        }

        public string Checking
        {
            get
            {
                return check;
            }
            set
            {
                this.RaiseAndSetIfChanged(ref check, value);
            }
        }

        public string ErrorMessage // Свойство для сообщения об ошибке
        {
            get => _errorMessage;
            set => this.RaiseAndSetIfChanged(ref _errorMessage, value);
        }

        public void timer_tick(object sender, EventArgs e)
        {
            Enabled = true;
        }

        private static Random random1 = new Random();
        public static string RandomString(int length)
        {
            const string chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
            return new string(Enumerable.Repeat(chars, length)
                .Select(s => s[random1.Next(s.Length)]).ToArray());
        }

        Canvas canva;

        public Canvas Canva
        {
            get => canva;
            set => this.RaiseAndSetIfChanged(ref canva, value);
        }
        public void CreateCaptcha()
        {
            kod = RandomString(7);
            Random rnd = new Random();
            SolidColorBrush color = new SolidColorBrush(Avalonia.Media.Color.FromRgb(
                Convert.ToByte(rnd.Next(256)),
                Convert.ToByte(rnd.Next(256)),
                Convert.ToByte(rnd.Next(256))
            ));

            int canvasWidth = 250;
            int canvasHeight = 80;
            Canvas canvas = new Canvas()
            {
                Width = canvasWidth,
                Height = canvasHeight,
                Background = color
            };


            int nach = rnd.Next(5, 10);
            foreach (char s in kod)
            {
                nach += 15 + rnd.Next(10);
                if (nach > canvasWidth - 20)
                {
                    nach = canvasWidth - 20;
                }

                TextBlock number = new TextBlock()
                {
                    Text = s.ToString(),
                    FontSize = 30,
                    Foreground = Brushes.Black,
                    Padding = new Avalonia.Thickness(nach, rnd.Next(10, 40)),
                    FontWeight = rnd.Next(2) == 0 ? FontWeight.Bold : FontWeight.Regular,
                    FontStyle = rnd.Next(2) == 0 ? FontStyle.Italic : FontStyle.Normal
                };
                canvas.Children.Add(number);
            }


            for (int i = 0; i < 10; i++)
            {
                Line line = new Line()
                {
                    StartPoint = new Avalonia.Point(rnd.Next(canvasWidth), rnd.Next(canvasHeight)),
                    EndPoint = new Avalonia.Point(rnd.Next(canvasWidth), rnd.Next(canvasHeight)),
                    Stroke = new SolidColorBrush(Avalonia.Media.Color.FromRgb(
                        Convert.ToByte(rnd.Next(250) + 3),
                        Convert.ToByte(rnd.Next(250) + 3),
                        Convert.ToByte(rnd.Next(250) + 3))
                    ),
                    StrokeThickness = 2
                };

                canvas.Children.Add(line);
            }

            Canva = canvas;
        }
    }
}
